## mhddfs 0.1.10

=== Makefile ===
#    mhddfs - Multi HDD [FUSE] File System
#    Copyright (C) 2008 Dmitry E. Oboukhov <dimka@avanto.org>

#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

SRC	=	$(wildcard src/*.c)

OBJ	=	$(SRC:src/%.c=obj/%.o)

DEPS	=	$(OBJ:obj/%.o=obj/%.d)

TARGET	=	mhddfs

CFLAGS	=	-Wall $(shell pkg-config fuse --cflags) -DFUSE_USE_VERSION=26 -MMD
LDFLAGS	=	$(shell pkg-config fuse --libs)

FORTAR	=	src COPYING LICENSE README Makefile README.ru.UTF-8 ChangeLog mhddfs.1

VERSION	=	$(shell cat src/version.h  \
	|grep '^.define'|grep '[[:space:]]VERSION[[:space:]]' \
	|awk '{print $$3}'|sed 's/\"//g' )

all: $(TARGET)

tarball: mhddfs_$(VERSION).tar.gz
	@echo '>>>> mhddfs_$(VERSION).tar.gz created'

mhddfs_$(VERSION).tar.gz: $(FORTAR) $(wildcard src/*)
	mkdir mhddfs-$(VERSION)
	cp -r $(FORTAR) mhddfs-$(VERSION)
	tar --exclude=.svn -czvf $@ mhddfs-$(VERSION)
	rm -fr mhddfs-$(VERSION)


$(TARGET): obj/obj-stamp $(OBJ)
	gcc $(CFLAGS) $(LDFLAGS) $(OBJ) -o $@

obj/obj-stamp:
	mkdir -p obj
	touch $@

obj/%.o: src/%.c
	gcc $(CFLAGS) -c $< -o $@

clean:
	rm -fr obj $(TARGET)

release_svn_thread:
	@echo current version $(VERSION)
	if ! svn ls http://svn.uvw.ru/mhddfs/tags| \
		grep -q release_$(VERSION); then \
		svn copy -m release-$(VERSION) \
			http://svn.uvw.ru/mhddfs/trunk \
			http://svn.uvw.ru/mhddfs/tags/release_$(VERSION); \
	fi

open_project:
	screen -t vim vim Makefile src/* README* ChangeLog mhddfs.1

.PHONY: all clean open_project tarball release_svn_thread

include $(wildcard obj/*.d)

## mhddfs 0.1.12

=== Makefile ===
--- 
+++ 
@@ -54,7 +54,7 @@
 	gcc $(CFLAGS) -c $< -o $@
 
 clean:
-	rm -fr obj $(TARGET)
+	rm -fr obj $(TARGET) pwrite_test
 
 release_svn_thread:
 	@echo current version $(VERSION)
@@ -68,6 +68,9 @@
 open_project:
 	screen -t vim vim Makefile src/* README* ChangeLog mhddfs.1
 
+pwrite_test: src/test/pwrite.c
+	gcc -o $@ $<
+
 .PHONY: all clean open_project tarball release_svn_thread
 
 include $(wildcard obj/*.d)

## mhddfs 0.1.18

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,9 @@
 CFLAGS	=	-Wall $(shell pkg-config fuse --cflags) -DFUSE_USE_VERSION=26 -MMD
 LDFLAGS	=	$(shell pkg-config fuse --libs)
 
-FORTAR	=	src COPYING LICENSE README Makefile README.ru.UTF-8 ChangeLog mhddfs.1
+FORTAR	=	src COPYING LICENSE README Makefile \
+		README.ru.UTF-8 ChangeLog mhddfs.1 \
+		debian
 
 VERSION	=	$(shell cat src/version.h  \
 	|grep '^.define'|grep '[[:space:]]VERSION[[:space:]]' \
@@ -36,7 +38,7 @@
 tarball: mhddfs_$(VERSION).tar.gz
 	@echo '>>>> mhddfs_$(VERSION).tar.gz created'
 
-mhddfs_$(VERSION).tar.gz: $(FORTAR) $(wildcard src/*)
+mhddfs_$(VERSION).tar.gz: $(FORTAR) $(wildcard src/*) 
 	mkdir mhddfs-$(VERSION)
 	cp -r $(FORTAR) mhddfs-$(VERSION)
 	tar --exclude=.svn -czvf $@ mhddfs-$(VERSION)
@@ -44,7 +46,7 @@
 
 
 $(TARGET): obj/obj-stamp $(OBJ)
-	gcc $(CFLAGS) $(LDFLAGS) $(OBJ) -o $@
+	gcc $(CFLAGS) $(OBJ) -o $@ $(LDFLAGS)
 
 obj/obj-stamp:
 	mkdir -p obj
@@ -66,11 +68,56 @@
 	fi
 
 open_project:
-	screen -t vim vim Makefile src/* README* ChangeLog mhddfs.1
+	screen -t vim vim Makefile src/*.[ch] README* ChangeLog mhddfs.1
 
 pwrite_test: src/test/pwrite.c
 	gcc -o $@ $<
 
-.PHONY: all clean open_project tarball release_svn_thread
+images-mount: test1.img test2.img
+	mount|grep -q `pwd`/test1 || sudo mount -o loop test1.img test1
+	mount|grep -q `pwd`/test2 || sudo mount -o loop test2.img test2
+	sudo chown -R `whoami` test1 test2
+
+test-mount:
+	rm -f logfile.log
+	mount|grep -q `pwd`/mnt && make test-umount || true
+	./$(TARGET) test1 test2 mnt -o \
+		logfile=logfile.log,mlimit=50m,nonempty,loglevel=0
+	df -h test1 test2
+	ls mnt
+
+test-umount:
+	-fusermount -u mnt
+
+test1.img:
+	dd if=/dev/zero of=$@ bs=1M count=100
+	echo y|/sbin/mkfs.ext3 $@
+
+test2.img:
+	dd if=/dev/zero of=$@ bs=1M count=200
+	echo y|/sbin/mkfs.ext3 $@
+
+test:
+	file_name=`mktemp -p mnt file_XXXXXXXXXX`; \
+		echo $$file_name; \
+		dd if=/dev/urandom of=$$file_name bs=1M count=1 2> /dev/null
+
+btest:
+	file_name=`mktemp -p mnt file_XXXXXXXXXX`; \
+		echo $$file_name; \
+		dd if=/dev/urandom bs=1M count=65 2> /dev/null \
+			|tee $$file_name \
+			|md5sum; \
+		md5sum $$file_name
+		
+
+tests:
+	while make test; do echo ok; echo; done
+
+test-images: test1.img test2.img
+
+.PHONY: all clean open_project tarball \
+	release_svn_thread test-mount test-umount \
+	images-mount test tests
 
 include $(wildcard obj/*.d)

## mhddfs 0.1.19

=== Makefile ===
--- 
+++ 
@@ -56,7 +56,7 @@
 	gcc $(CFLAGS) -c $< -o $@
 
 clean:
-	rm -fr obj $(TARGET) pwrite_test
+	rm -fr obj $(TARGET) pwrite_test statvfs
 
 release_svn_thread:
 	@echo current version $(VERSION)
@@ -71,6 +71,9 @@
 	screen -t vim vim Makefile src/*.[ch] README* ChangeLog mhddfs.1
 
 pwrite_test: src/test/pwrite.c
+	gcc -o $@ $<
+
+statvfs: src/test/statvfs.c
 	gcc -o $@ $<
 
 images-mount: test1.img test2.img

## mhddfs 0.1.28

=== Makefile ===
--- 
+++ 
@@ -32,6 +32,9 @@
 VERSION	=	$(shell cat src/version.h  \
 	|grep '^.define'|grep '[[:space:]]VERSION[[:space:]]' \
 	|awk '{print $$3}'|sed 's/\"//g' )
+RELEASE	=	0
+
+SRCDIR	=	$(shell rpm --eval '%_sourcedir')
 
 all: $(TARGET)
 
@@ -44,6 +47,12 @@
 	tar --exclude=.svn -czvf $@ mhddfs-$(VERSION)
 	rm -fr mhddfs-$(VERSION)
 
+rpm: tarball
+	mkdir -p $(SRCDIR)
+	mv -f mhddfs_$(VERSION).tar.gz $(SRCDIR)
+	rpmbuild -ba mhddfs.spec --define 'version $(VERSION)' --define 'release $(RELEASE)'
+	cp $(shell rpm --eval '%_srcrpmdir')/mhddfs-$(VERSION)-$(RELEASE)* \
+		$(shell rpm --eval '%_rpmdir')/*/mhddfs-*$(VERSION)-$(RELEASE)* .
 
 $(TARGET): obj/obj-stamp $(OBJ)
 	gcc $(CFLAGS) $(OBJ) -o $@ $(LDFLAGS)
@@ -56,8 +65,13 @@
 	gcc $(CFLAGS) -c $< -o $@
 
 clean:
-	rm -fr obj $(TARGET) pwrite_test statvfs
+	rm -fr obj $(TARGET) pwrite_test statvfs rename
+	fusermount -u rename-test || true
+	rm -fr rename-test/mnt
 
+rename: tests/rename.c
+	gcc -o $@ $<
+	
 release_svn_thread:
 	@echo current version $(VERSION)
 	if ! svn ls http://svn.uvw.ru/mhddfs/tags| \
@@ -117,10 +131,34 @@
 tests:
 	while make test; do echo ok; echo; done
 
+ptest:
+	gcc -o $@ tests/plocks.c -l pthread
+	-./$@
+	rm -f $@
+
 test-images: test1.img test2.img
+
+rename-test: $(TARGET)
+	fusermount -u $@/mnt || true
+	rm -f logfile.log
+	rm -fr $@
+	mkdir $@ $@/1 $@/2 $@/mnt
+	./$(TARGET) $@/1 $@/2 $@/mnt -o logfile=logfile.log,loglevel=0
+	touch $@/mnt/test-file
+	mv $@/mnt/test-file $@/mnt/test-file.1
+	mkdir $@/mnt/test-dir
+	mv $@/mnt/test-dir $@/mnt/test-dir.1
+	mkdir $@/2/test-dir.2
+	touch $@/2/test-dir.2/123
+	mkdir $@/mnt/test-dir.3
+	mv $@/mnt/test-dir.2/123 $@/mnt/test-dir.3
+	fusermount -u $@/mnt
+	rm -fr $@
+	@echo '******************** PASSED ***********************'
 
 .PHONY: all clean open_project tarball \
 	release_svn_thread test-mount test-umount \
-	images-mount test tests
+	images-mount test tests rename-test
 
 include $(wildcard obj/*.d)
+

## mhddfs 0.1.35

=== Makefile ===
--- 
+++ 
@@ -22,7 +22,12 @@
 
 TARGET	=	mhddfs
 
-CFLAGS	=	-Wall $(shell pkg-config fuse --cflags) -DFUSE_USE_VERSION=26 -MMD
+CFLAGS	=	-Wall $(shell pkg-config fuse --cflags) \
+			-DFUSE_USE_VERSION=26 -MMD
+ifdef WITHOUT_XATTR
+CFLAGS	+=	-DWITHOUT_XATTR
+endif
+
 LDFLAGS	=	$(shell pkg-config fuse --libs)
 
 FORTAR	=	src COPYING LICENSE README Makefile \
@@ -37,6 +42,10 @@
 SRCDIR	=	$(shell rpm --eval '%_sourcedir')
 
 all: $(TARGET)
+
+help:
+	@echo usage: make - to build program
+	@echo make WITHOUT_XATTR=1 - to build program without xattr functional
 
 tarball: mhddfs_$(VERSION).tar.gz
 	@echo '>>>> mhddfs_$(VERSION).tar.gz created'
@@ -136,6 +145,11 @@
 	-./$@
 	rm -f $@
 
+symlinks_test: $(TARGET)
+	bash tests/utimes.sh
+
+
+
 test-images: test1.img test2.img
 
 rename-test: $(TARGET)
@@ -158,7 +172,8 @@
 
 .PHONY: all clean open_project tarball \
 	release_svn_thread test-mount test-umount \
-	images-mount test tests rename-test
+	images-mount test tests rename-test \
+	help
 
 include $(wildcard obj/*.d)

=== debian/changelog ===
mhddfs (0.1.35) unstable; urgency=low

  * Debian/kfreebsd architectures are built using WITHOUT_XATTR=1 build flag,
    fixes a few build warnings.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 15 Jun 2010 09:44:23 +0400

mhddfs (0.1.34) unstable; urgency=low

  * Fixed dependencies on freebsd.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 03 Jun 2010 21:51:48 +0400

mhddfs (0.1.33) unstable; urgency=low

  * Symlinks are processed properly (set date/time), closes: #575847,
    thanks for Jools Wills <jools@oxfordinspire.co.uk> for bugreport.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 01 Jun 2010 16:31:20 +0400

mhddfs (0.1.32) unstable; urgency=low

  * Switch to dpkg-source 3.0 (native) format.
  * Added startup check to remove duplicaties of mount directories,
  	closes: #582888.
  * Debian is upstream linux variant, so we will use debian native
    package format.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 01 Jun 2010 15:09:37 +0400

mhddfs (0.1.31-1) unstable; urgency=low

  * Fixed statvfs if a few shares are placed onto one device, closes: #580785.
  * Added libattr1-dev in B-D, fixed FTBFS, closes: #565037.
  * Closes unreproducible bugreport (a few months passed), closes: #512649.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 01 Jun 2010 12:07:00 +0400

mhddfs (0.1.30-1) UNRELEASE; urgency=low

  * Another BSD build problem.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 11 Jan 2010 23:07:30 +0300

mhddfs (0.1.29-1) UNRELEASE; urgency=low

  * Building under FreeBSD is fixed.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 11 Jan 2010 11:49:17 +0300

mhddfs (0.1.28-1) unstable; urgency=high

  * Fixed creating parent directories when item is moved between shares. 

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 18 Dec 2009 22:59:15 +0300

mhddfs (0.1.27-1) unstable; urgency=high

  * Fixed renaming a directory bug,
    thanks for Nathan Grennan <dimka@cygnusx-1.org>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 12 Dec 2009 14:24:22 +0300

mhddfs (0.1.26-1) unstable; urgency=low

  * Fixed memory leak in extended attribute patch.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 26 Nov 2009 00:37:42 +0300

mhddfs (0.1.25-1) unstable; urgency=low

  * Rewite rename mechanizm to properly rename directories which are
    present in many hdds.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 16 Nov 2009 00:25:36 +0300

mhddfs (0.1.24-1) unstable; urgency=low

  * Applied extended attribute patch, thanks for
    Glenn Washburn <gwashburn@Crossroads.com>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 30 Oct 2009 09:52:00 +0300

mhddfs (0.1.23-1) unstable; urgency=low

  * Fixed rename mechanizm if files are in different hdds, closes: #547172,
    tanks to Pozsar Balazs <pozsy@uhulinux.hu> for bugreport.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 29 Sep 2009 12:51:02 +0400

mhddfs (0.1.22-1) unstable; urgency=low

  * Finally fixed deadlock when it moves file between sources.
  * Bumped Standards-Version to 3.8.2.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 02 Jul 2009 18:04:18 +0400

mhddfs (0.1.21-1) unstable; urgency=low

  * Fixed deadlock when it closes bad file descrioption.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 02 Jul 2009 12:09:17 +0400

mhddfs (0.1.20-1) unstable; urgency=low

  * New upstream version.
   * Fixed possible deadlock when it moves file between sources.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 01 Jul 2009 09:28:29 +0400

mhddfs (0.1.19-1) unstable; urgency=low

  * Check free space is better than before: code will return the error if
    it does not find free space.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 11 Mar 2009 12:55:19 +0300

mhddfs (0.1.18-1) unstable; urgency=low

  * New upstream release. Fixed deadlocks.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 29 Dec 2008 12:06:57 +0300

mhddfs (0.1.17-1) unstable; urgency=low

  * New upstream release. Now the mount's directories can be
    input with the help of spaces. closes: #508330.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 12 Dec 2008 22:53:44 +0300

mhddfs (0.1.17~debug-1) norelease; urgency=low

  * Test version for find segfault.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 24 Oct 2008 12:16:17 +0400

mhddfs (0.1.16-1) unstable; urgency=low

  * Revert to old lock-scheme.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 20 Oct 2008 15:20:10 +0400

mhddfs (0.1.15-1) unstable; urgency=low

  * New upstream release (fixed segfault on mhdd_fileopen).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 20 Oct 2008 14:44:47 +0400

mhddfs (0.1.13-1) unstable; urgency=low

  * New release.
  * Fix few linker options, closes: #499380.
  * Added lock for debug-stream when writing debug messages.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 13 Oct 2008 15:32:01 +0400

mhddfs (0.1.12-1) unstable; urgency=low

  * New release (Now SGID-bit works fine).
  * Added Vcs-Browser: to debian/control.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 11 Jul 2008 23:38:18 +0400

mhddfs (0.1.11-1) unstable; urgency=medium

  * New release (fix detect filesystem overflow. Thanks lordikc
    <lordikc@free.fr>.)
  * Standards-Version bumped to 3.8.0.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 16 Jun 2008 23:47:54 +0400

mhddfs (0.1.10-2) unstable; urgency=low

  * My email address has been changed.

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 30 May 2008 07:56:05 +0400

mhddfs (0.1.10-1) unstable; urgency=low

  * New release.
  * Upload sponsored by Al Nikolov <clown@debian.org>

 -- Dmitry E. Oboukhov <dimka@avanto.org>  Sun,  4 May 2008 18:28:15 +0400

mhddfs (0.1.8-2) unstable; urgency=low

  * Changed description, closes: #477796.
  * Added homepage url to debian/control.
  * Upload sponsored by Al Nikolov <clown@debian.org>

 -- Dmitry E. Oboukhov <dimka@avanto.org>  Fri, 25 Apr 2008 14:50:09 +0400

mhddfs (0.1.8-1) unstable; urgency=low

  * New release.
  * Upload sponsored by Al Nikolov <clown@debian.org>



## mhddfs 0.1.37

=== debian/changelog ===
mhddfs (0.1.37) unstable; urgency=low

  * Old default mlimit is used.
  * mlimit=100% is a reasonable request.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 13 Jul 2010 17:05:40 +0400

mhddfs (0.1.36) experimental; urgency=low

  * Since now mhddfs uses 'mlimit' option in percent,
    thanks for Robert de Bath <robert@tvisiontech.co.uk>, closes: #588892.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 13 Jul 2010 15:18:37 +0400

## mhddfs 0.1.38

=== Makefile ===
--- 
+++ 
@@ -37,11 +37,30 @@
 VERSION	=	$(shell cat src/version.h  \
 	|grep '^.define'|grep '[[:space:]]VERSION[[:space:]]' \
 	|awk '{print $$3}'|sed 's/\"//g' )
+
+DEBVERSION =	$(shell \
+	head -n 1 debian/changelog \
+		| awk '{print $$2}' \
+		| sed 's/^.//' | sed 's/.$$//' \
+		| sed 's/-[[:digit:]]\+$$//' \
+)
+
 RELEASE	=	0
 
 SRCDIR	=	$(shell rpm --eval '%_sourcedir')
 
+
+ifeq ($(DEBVERSION), $(VERSION))
 all: $(TARGET)
+else
+all: update_version $(TARGET)
+endif
+
+update_version:
+	@echo Updating upstream version from $(VERSION) to $(DEBVERSION)...
+	@sleep 5
+	perl -pi -e 's/^(#define\s+VERSION\s+).*/$$1 "$(DEBVERSION)"/' \
+		src/version.h
 
 help:
 	@echo usage: make - to build program
@@ -173,7 +192,7 @@
 .PHONY: all clean open_project tarball \
 	release_svn_thread test-mount test-umount \
 	images-mount test tests rename-test \
-	help
+	help update_version
 
 include $(wildcard obj/*.d)

=== debian/changelog ===
mhddfs (0.1.38) unstable; urgency=low

  * Apply hardlinks patch, big thanks for patch to
    Dermot Duffy <dermot.duffy@gmail.com>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 04 May 2011 12:23:01 +0400

=== debian/control ===
Source: mhddfs
Section: utils
Priority: extra
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: debhelper (>= 5), libfuse-dev, pkg-config, libattr1-dev
Standards-Version: 3.8.4
Homepage: http://mhddfs.uvw.ru
Vcs-Browser: http://svn.uvw.ru/mhddfs/trunk

Package: mhddfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 fuse-utils [!kfreebsd-amd64 !kfreebsd-i386]
Description: file system for unifying several mount points into one
 This FUSE-based file system allows mount points (or directories) to be
 combined, simulating a single big volume which can merge several hard
 drives or remote file systems. It is like unionfs, but can choose the
 drive with the most free space to create new files on, and can move
 data transparently between drives.

## mhddfs 0.1.39

=== debian/changelog ===
mhddfs (0.1.39) unstable; urgency=low

  * Kalyanov Dmitry optimized readdir function: now we use HASH-tables
    to deduplicate directories.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 17 Jun 2012 17:46:43 +0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,11 @@
 Section: utils
 Priority: extra
 Maintainer: Dmitry E. Oboukhov <unera@debian.org>
-Build-Depends: debhelper (>= 5), libfuse-dev, pkg-config, libattr1-dev
+Build-Depends: debhelper (>= 5),
+ libfuse-dev,
+ pkg-config,
+ libattr1-dev,
+ uthash-dev
 Standards-Version: 3.8.4
 Homepage: http://mhddfs.uvw.ru
 Vcs-Browser: http://svn.uvw.ru/mhddfs/trunk

## mhddfs 0.1.39ubuntu1

=== debian/changelog ===
mhddfs (0.1.39ubuntu1) raring; urgency=low

  * Makefile: Add -pthread to LDFLAGS to fix underlinking FTBFS.

 -- Logan Rosen <logan@ubuntu.com>  Fri, 19 Apr 2013 15:50:03 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mhddfs
 Section: utils
 Priority: extra
-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
 Build-Depends: debhelper (>= 5),
  libfuse-dev,
  pkg-config,

## mhddfs 0.1.39%2Bnmu1ubuntu1

=== debian/changelog ===
mhddfs (0.1.39+nmu1ubuntu1) saucy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Makefile: Add -pthread to LDFLAGS to fix underlinking FTBFS.

 -- Logan Rosen <logan@ubuntu.com>  Wed, 15 May 2013 18:42:09 -0400

mhddfs (0.1.39+nmu1) unstable; urgency=low

  * Non-maintainer upload.
  * Depend on fuse instead of fuse-utils. (Closes: #698128)

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 12 May 2013 15:35:08 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Package: mhddfs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- fuse-utils [!kfreebsd-amd64 !kfreebsd-i386]
+ fuse [!kfreebsd-amd64 !kfreebsd-i386]
 Description: file system for unifying several mount points into one
  This FUSE-based file system allows mount points (or directories) to be
  combined, simulating a single big volume which can merge several hard

## mhddfs 0.1.39%2Bnmu2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

MHDDFS_BUILDFLAGS	=

FREEBSD_FLAGS	= $(shell \
	if `dpkg-architecture -qDEB_BUILD_ARCH|grep -q 'kfreebsd'`; then \
		echo WITHOUT_XATTR=1; \
	fi \
)

MHDDFS_BUILDFLAGS	+= $(FREEBSD_FLAGS)

build: build-stamp

build-stamp: 
	dh_testdir
	make $(MHDDFS_BUILDFLAGS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	make clean
	rm -f build-stamp
	dh_clean 

# Build architecture-independent files here.
binary-indep: build install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_install
	dh_installman
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

build-arch: build
build-indep: build
binary: binary-indep binary-arch
.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install configure

## mhddfs 0.1.39+nmu1

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mhddfs
 Section: utils
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
+Maintainer: Dmitry E. Oboukhov <unera@debian.org>
 Build-Depends: debhelper (>= 5),
  libfuse-dev,
  pkg-config,

## mhddfs 0.1.39+nmu1ubuntu2

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 CFLAGS	+=	-DWITHOUT_XATTR
 endif
 
-LDFLAGS	=	$(shell pkg-config fuse --libs)
+LDFLAGS	=	$(shell pkg-config fuse --libs) -pthread
 
 FORTAR	=	src COPYING LICENSE README Makefile \
 		README.ru.UTF-8 ChangeLog mhddfs.1 \
@@ -189,6 +189,24 @@
 	rm -fr $@
 	@echo '******************** PASSED ***********************'
 
+dirtree-test: $(TARGET)
+	fusermount -u $@/mnt || true
+	rm -f logfile.log
+	rm -fr $@
+	mkdir $@ $@/1 $@/2 $@/mnt
+	./$(TARGET) $@/1 $@/2 $@/mnt -o logfile=logfile.log,loglevel=0
+	bash -c 'touch $@/1/{1,2,3,4} $@/2/{3,4,5,6}'
+	test `find $@/mnt -type f | sort -u |wc -l` -eq 6
+	test -e $@/mnt/1
+	test -e $@/mnt/2
+	test -e $@/mnt/3
+	test -e $@/mnt/4
+	test -e $@/mnt/5
+	test -e $@/mnt/6
+	fusermount -u $@/mnt
+	rm -fr $@
+	@echo '******************** PASSED ***********************'
+
 .PHONY: all clean open_project tarball \
 	release_svn_thread test-mount test-umount \
 	images-mount test tests rename-test \

=== debian/changelog ===
mhddfs (0.1.39+nmu1ubuntu2) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:34:43 +0000

=== debian/rules ===
--- 
+++ 
@@ -48,7 +48,5 @@
 	dh_md5sums
 	dh_builddeb
 
-build-arch: build
-build-indep: build
 binary: binary-indep binary-arch
-.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install configure
+.PHONY: build clean binary-indep binary-arch binary install configure

## mhddfs 0.1.39+nmu2

=== debian/changelog ===
mhddfs (0.1.39+nmu2) unstable; urgency=low

  * Non-maintainer upload.
  * debian/compat: 5 -> 7. (Closes: #965728)
  * debian/rules: Add build-{arch,indep}. (Closes: #999269)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Dec 2021 20:53:48 +0200

## mhddfs 0.1.39+nmu2build2

=== debian/changelog ===
mhddfs (0.1.39+nmu2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:00:59 +1100

mhddfs (0.1.39+nmu2build1) noble; urgency=high

  * No change rebuild against libfuse2t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:41:55 +0100

## mhddfs 0.1.39.0

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 CFLAGS	+=	-DWITHOUT_XATTR
 endif
 
-LDFLAGS	=	$(shell pkg-config fuse --libs) -pthread
+LDFLAGS	=	$(shell pkg-config fuse --libs)
 
 FORTAR	=	src COPYING LICENSE README Makefile \
 		README.ru.UTF-8 ChangeLog mhddfs.1 \

=== debian/changelog ===
mhddfs (0.1.39.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Maintain in Package Salvage Team
    Closes: #638497, #1106726
  * Switch from deprecated <attr/xattr.h> to <sys/xattr.h>
    Closes: #953919
  * d/rules: short dh (note: build-time test deactivated since failing)
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * No tab in license text (routine-update)
  * Secure URI in Homepage
  * Use [linux-any] instead of hardcoded list of non-Linux architectures
    Closes: #634517

  [ Ramkumar Natarajan ]
  * Fix crash due to use after free bug
    Closes: #876252

  [ Helmut Grohne ]
  * Enable cross building
    Closes: #923638

  [ наб ]
  * d/p/:
      26d0f1...  remove spurious uthash.h addition(?)
      0004  Forward CFLAGS from environment
      0005  -Wformat-security
      0006  Build with FUSE3 (Closes: #1084426)
      0007  Run mhddfs instead of ./mhddfs in tests, umount properly in tests
      0008  Fix utimens for FUSE3 (as found by autopgtest)
      0009  sleep 1 after instead of before spawning mhddfs in utimes.sh test
      0010  Use CPPFLAGS correctly
      0011  _GNU_SOURCE instead of _BSD_SOURCE &c.
      0012  Use LIBS/LDFLAGS correctly
  * Ignore odd-historical-debian-changelog-version
  * Fully disable tests during build
  * Run  make rename-test dirtree-test symlinks_test  as autpkgtests

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Wed, 28 May 2025 17:33:05 +0200

=== debian/control ===
Source: mhddfs
Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
Uploaders: Dmitry E. Oboukhov <unera@debian.org>, наб <nabijaczleweli@nabijaczleweli.xyz>
Section: utils
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libfuse3-dev,
               pkgconf,
               libattr1-dev,
               uthash-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/salvage-team/mhddfs
Vcs-Git: https://salsa.debian.org/salvage-team/mhddfs.git
Homepage: https://mhddfs.uvw.ru

Package: mhddfs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         fuse3 [linux-any]
Description: file system for unifying several mount points into one
 This FUSE-based file system allows mount points (or directories) to be
 combined, simulating a single big volume which can merge several hard
 drives or remote file systems. It is like unionfs, but can choose the
 drive with the most free space to create new files on, and can move
 data transparently between drives.

=== debian/rules ===
#!/usr/bin/make -f

FREEBSD_FLAGS	= $(shell \
	if `dpkg-architecture -qDEB_BUILD_ARCH|grep -q 'kfreebsd'`; then \
		echo WITHOUT_XATTR=1; \
	fi \
)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- mhddfs $(FREEBSD_FLAGS)

override_dh_auto_test:

=== debian/tests/control ===
Test-Command: exec make rename-test dirtree-test symlinks_test 2>&1
Depends: @, fuse3, rsync,  make
Restrictions: isolation-machine
# Needs to load fuse.ko
